Status: Rejected Priority: Should have
Author: Robert Lemke Category: Validation
Created: 2009-07-24 Assigned To:
Updated: 2012-03-13 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: FLOW3 1.0.0
Subject: TextValidator is insecure
Description

The TextValidator currently allows strings like

%3cspan style="color: #BBBBBB;"%3ea nice text%3c/span%3e

It seems like we can't solve this completely with filter_var because then characters like percent, semikolon, quotes etc. can't be used
in a text. In general the test case lacks realistic string which should pass the validator.

Related issues:
related to TYPO3.Flow - Bug # 2851: TextValidator is insecure Resolved 2009-03-16

Associated revisions
Revision 043cd78b - 2009-07-24 17:34 - Robert Lemke

[~BUGFIX] FLOW3 (Validation): The ValidatorResolver test case failed - but only if the Blog package was installed. This was due to some Blog model
being used by a data provider which in reality should have been a sample, not existing class. Fixed that.
[~TASK] FLOW3 (Validation): The TextValidator was too restrictive because it did not allow line breaks and other common characters - now it does.
However, it's not really secure yet. Relates to #3977
[+BUGFIX] Fluid (Core): Added some safe guard and aception to the Abstract Node which would exit with a fatal error in some cases.

Revision cfa4bd55 - 2012-04-02 14:09 - Christian Müller

[TASK] Improve TextValidator unit tests

This introduces more test texts for the TextValidator tests.

Change-Id: Ie461a82fec5ead10941031c53e32694d4d0b44d2
Related: #3977
Releases: 1.0, 1.1

History
#1 - 2009-08-17 11:32 - Robert Lemke
- Target version deleted (1.0 alpha 3)

#2 - 2010-01-13 16:38 - Robert Lemke
- Target version set to 1.0 alpha 8
#3 - 2010-01-20 12:11 - Karsten Dambekalns
- File TextValidatorTest.php.patch added
- Priority changed from Could have to Should have

Attached a patch for the unit test that makes adding new valid and invalid input easier.

#4 - 2010-03-09 17:38 - Robert Lemke
- Status changed from New to Accepted
- Assigned To set to Robert Lemke
- % Done changed from 0 to 20
- Estimated time set to 6.00

#5 - 2010-03-11 11:42 - Robert Lemke
- Start date deleted (2009-03-16)

#6 - 2010-04-15 22:25 - Karsten Dambekalns
- Target version changed from 1.0 alpha 8 to 1.0 alpha 9

#7 - 2010-05-28 17:37 - Robert Lemke
- Target version deleted (1.0 alpha 9)

#8 - 2011-10-21 13:20 - Karsten Dambekalns
- Affected Flow version set to FLOW3 1.0.0

#9 - 2012-01-18 19:21 - Bastian Waidelich
- Has patch set to No

IMO TextValidator should be removed as it depends on the context whether a string is insecure or not (also see comment at #6121)

#10 - 2012-03-13 13:13 - Christian Müller
- Status changed from Accepted to Rejected
- Assigned To deleted (Robert Lemke)

The test improvements are in review now, I will close this, we could decide to deprecate the TextValidator at some point. I added also some longer
comment to the TextValidator to point out that it won't make sure the validated string is secure in all possible output environments.

Files
TextValidatorTest.php.patch 4.8 kB 2010-01-20 Karsten Dambekalns
